---
title: HTMLVideoElement.requestPictureInPicture()
slug: Web/API/HTMLVideoElement/requestPictureInPicture
tags:
  - API
  - Experimental
  - HTML DOM
  - HTMLVideoElement
  - Media
  - Method
  - Picture-in-Picture
  - Picture-in-Picture API
  - Reference
  - Video
  - pip
---
<div>{{ APIRef("HTML DOM") }}</div>

<p><span class="seoSummary">The <strong>{{domxref("HTMLVideoElement")}}</strong> method <code><strong>requestPictureInPicture()</strong></code> issues an asynchronous request to display the video in picture-in-picture mode.</span></p>

<p>It's not guaranteed that the video will be put into picture-in-picture. If permission to enter that mode is granted, the returned {{domxref("Promise")}} will resolve and the video will receive a {{Event("enterpictureinpicture")}} event to let it know that it's now in picture-in-picture.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate"><em>videoElement</em>.requestPictureInPicture();</pre>

<h3 id="Return_value">Return value</h3>

<p>A {{domxref("Promise")}} that will resolve to a {{domxref("PictureInPictureWindow")}} object. that can be used to listen when a user will resize that floating window.</p>

<h2 id="Examples">Examples</h2>

<p>This example requests that the video enters Picture-in-Picture mode, and sets an event listener to handle the floating window resizing.</p>

<pre class="brush: js notranslate">function enterPictureInPicture() {
  videoElement.requestPictureInPicture()
    .then(pictureInPictureWindow =&gt; {
      pictureInPictureWindow.addEventListener("resize", () =&gt; onPipWindowResize(), false);
    })
}
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Picture-in-Picture', '#request-pip', 'HTMLVideoElement.requestPictureInPicture()')}}</td>
   <td>{{Spec2('Picture-in-Picture')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.HTMLVideoElement.requestPictureInPicture")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li>The {{HTMLElement("video")}} element</li>
 <li>{{DOMxRef("HTMLVideoElement.autoPictureInPicture")}}</li>
 <li>{{DOMxRef("HTMLVideoElement.disablePictureInPicture")}}</li>
 <li>{{DOMxRef("Document.pictureInPictureEnabled")}}</li>
 <li>{{DOMxRef("Document.exitPictureInPicture()")}}</li>
 <li>{{DOMxRef("DocumentOrShadowRoot.pictureInPictureElement")}}</li>
 <li>{{CSSxRef(":picture-in-picture")}}</li>
</ul>
